import { PostgrestSingleResponse, PostgrestMaybeSingleResponse, PostgrestResponse } from '@supabase/supabase-js';

declare const DEFAULT_SCHEMA_NAME = "default";

declare type PostgrestPaginationCacheData<Type> = Type[][];
declare type PostgrestCacheData<Type> = Pick<PostgrestSingleResponse<Type>, "data"> | Pick<PostgrestMaybeSingleResponse<Type>, "data"> | Pick<PostgrestResponse<Type>, "data" | "count"> | PostgrestPaginationCacheData<Type>;
declare const isPaginationCacheData: <Type>(data: PostgrestCacheData<Type>) => data is PostgrestPaginationCacheData<Type>;
declare type PostgrestMutatorOpts<Type> = {
    /**
     * Will set all keys of the tables to stale
     */
    revalidateTables?: {
        schema?: string;
        table: string;
    }[];
    /**
     * Will set all keys of the tables where relation.primaryKey === myObj.fKey
     */
    revalidateRelations?: {
        schema?: string;
        relation: string;
        relationIdColumn: string;
        fKeyColumn: keyof Type;
    }[];
    schema?: string;
};

export { DEFAULT_SCHEMA_NAME, PostgrestCacheData, PostgrestMutatorOpts, isPaginationCacheData };
